Subject: Re: Old regression with MTD devices disappearing from a Kurobox HD/HG

From: Rogério Brito <[email-masked]>
Date: Thu, 16 Apr 2015 21:14:09 -0300

Hi, Scott.

On Apr 16 2015, Scott Wood wrote:
> On Thu, 2015-04-16 at 21:01 -0300, Rogério Brito wrote:
> > On Apr 16 2015, Scott Wood wrote:
> > > On Thu, 2015-04-16 at 19:55 -0300, Rogério Brito wrote:
> > > > Is there any "proper" way for me to discover what device name the kernel
> > > > uses? I have tried the following command lines without success:
> > > > 
> > > > 1 - mtdparts=myflash:4096k(allflash),3072k(firmimg),448k@3072k(bootcode),64k@3520k(status),512k@3584k(conf)
> > > > 2 - mtdparts=physmap-flash:3072k(firmimg),448k@3072k(bootcode),64k@3520k(status),512k@3584k(conf)
> > > > 3 - mtdparts=cfi_cmdset_0002:3072k(firmimg),448k@3072k(bootcode),64k@3520k(status),512k@3584k(conf)
> > > 
> > > Look in sysfs.
> > 
> > The output that I get from sysfs is:
> > 
> >     # ls -l /sys/block/mtdblock0
> >     lrwxrwxrwx 1 root root 0 Apr 16 20:42 /sys/block/mtdblock0 -> ../devices/platform/physmap-flash.0/mtd/mtd0/mtdblock0
> >     # cat /sys/devices/platform/physmap-flash.0/uevent
> >     DRIVER=physmap-flash
> >     MODALIAS=platform:physmap-flash
> >     # cat /sys/devices/platform/physmap-flash.0/driver_override
> >     (null)
> > 
> > So, it is saying that the driver is physmap-flash, right?
> 
> It looks like the device name is "physmap-flash.0".  You're partitioning
> the device, not the driver.

Sure, the device, not the driver. :) I simply thought that the trailing .0
was a way to disambiguate from multiple devices that might (perhaps) be
activated by the same driver.

Regardless, I guess that I have already tried this physmap-flash.0 thing,
but I will let you know the results in a few minutes. :) I have just
finished compiling the kernel with that (forced) command line and I'm
rebooting the system now.

----

Yay! It worked:

,----
| physmap platform flash device: 00400000 at ffc00000
| physmap-flash.0: Found 1 x16 devices at 0x0 in 8-bit bank. Manufacturer ID 0x000004 Chip ID 0x00007e
| Amd/Fujitsu Extended Query Table at 0x0040
|   Amd/Fujitsu Extended Query version 1.3.
| physmap-flash.0: Swapping erase regions for top-boot CFI table.
| number of CFI chips: 1
| 4 cmdlinepart partitions found on MTD device physmap-flash.0
| Creating 4 MTD partitions on "physmap-flash.0":
| 0x000000000000-0x000000300000 : "firmimg"
| 0x000000300000-0x000000370000 : "bootcode"
| 0x000000370000-0x000000380000 : "status"
| 0x000000380000-0x000000400000 : "conf"
`----

Now, the next step is to learn this DTS thing and send patches to two DTS
files.  :)

Thank you so very much,

-- 
Rogério Brito : rbrito@{ime.usp.br,gmail.com} : GPG key 4096R/BCFCAAAA
http://cynic.cc/blog/ : github.com/rbrito : profiles.google.com/rbrito
DebianQA: http://qa.debian.org/developer.php?login=rbrito%40ime.usp.br